1. Registry
  2. Packages
  3. AWS Cloud Control
  4. API Docs
  5. mediatailor
  6. Function

We recommend new projects start with resources from the AWS provider.

Viewing docs for AWS Cloud Control v1.85.0
published on Monday, Nov 2, 2026 by Pulumi
aws-native logo aws-native logo AWS Cloud Control

We recommend new projects start with resources from the AWS provider.

Viewing docs for AWS Cloud Control v1.85.0
published on Monday, Nov 2, 2026 by Pulumi

    Resource Type definition for AWS::MediaTailor::Function

    Create Function Resource

    Resources are created with functions called constructors. To learn more about declaring and configuring resources, see Resources.

    Constructor syntax

    new Function(name: string, args: FunctionArgs, opts?: CustomResourceOptions);
    @overload
    def Function(resource_name: str,
                 args: FunctionArgs,
                 opts: Optional[ResourceOptions] = None)
    
    @overload
    def Function(resource_name: str,
                 opts: Optional[ResourceOptions] = None,
                 function_id: Optional[str] = None,
                 function_type: Optional[FunctionType] = None,
                 aws_service_request_configuration: Optional[FunctionAwsServiceRequestConfigurationArgs] = None,
                 concurrent_executor_configuration: Optional[FunctionConcurrentExecutorConfigurationArgs] = None,
                 custom_output_configuration: Optional[FunctionCustomOutputConfigurationArgs] = None,
                 description: Optional[str] = None,
                 http_request_configuration: Optional[FunctionHttpRequestConfigurationArgs] = None,
                 sequential_executor_configuration: Optional[FunctionSequentialExecutorConfigurationArgs] = None,
                 tags: Optional[Sequence[_root_inputs.TagArgs]] = None,
                 vast_request_configuration: Optional[FunctionVastRequestConfigurationArgs] = None)
    func NewFunction(ctx *Context, name string, args FunctionArgs, opts ...ResourceOption) (*Function, error)
    public Function(string name, FunctionArgs args, CustomResourceOptions? opts = null)
    public Function(String name, FunctionArgs args)
    public Function(String name, FunctionArgs args, CustomResourceOptions options)
    
    type: aws-native:mediatailor:Function
    properties: # The arguments to resource properties.
    options: # Bag of options to control resource's behavior.
    
    
    resource "aws-native_mediatailor_function" "name" {
        # resource properties
    }

    Parameters

    name string
    The unique name of the resource.
    args FunctionArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    resource_name str
    The unique name of the resource.
    args FunctionArgs
    The arguments to resource properties.
    opts ResourceOptions
    Bag of options to control resource's behavior.
    ctx Context
    Context object for the current deployment.
    name string
    The unique name of the resource.
    args FunctionArgs
    The arguments to resource properties.
    opts ResourceOption
    Bag of options to control resource's behavior.
    name string
    The unique name of the resource.
    args FunctionArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    name String
    The unique name of the resource.
    args FunctionArgs
    The arguments to resource properties.
    options CustomResourceOptions
    Bag of options to control resource's behavior.

    Function Resource Properties

    To learn more about resource properties and how to use them, see Inputs and Outputs in the Architecture and Concepts docs.

    Inputs

    In Python, inputs that are objects can be passed either as argument classes or as dictionary literals.

    The Function resource accepts the following input properties:

    FunctionId string
    The unique identifier for the function.
    FunctionType Pulumi.AwsNative.MediaTailor.FunctionType
    The type of the function. Determines which configuration object is used.
    AwsServiceRequestConfiguration Pulumi.AwsNative.MediaTailor.Inputs.FunctionAwsServiceRequestConfiguration
    ConcurrentExecutorConfiguration Pulumi.AwsNative.MediaTailor.Inputs.FunctionConcurrentExecutorConfiguration
    The configuration for a CONCURRENT_EXECUTOR function. Required when FunctionType is CONCURRENT_EXECUTOR.
    CustomOutputConfiguration Pulumi.AwsNative.MediaTailor.Inputs.FunctionCustomOutputConfiguration
    Description string
    A description of the function.
    HttpRequestConfiguration Pulumi.AwsNative.MediaTailor.Inputs.FunctionHttpRequestConfiguration
    SequentialExecutorConfiguration Pulumi.AwsNative.MediaTailor.Inputs.FunctionSequentialExecutorConfiguration
    Tags List<Pulumi.AwsNative.Inputs.Tag>
    The tags to assign to the function resource.
    VastRequestConfiguration Pulumi.AwsNative.MediaTailor.Inputs.FunctionVastRequestConfiguration
    FunctionId string
    The unique identifier for the function.
    FunctionType FunctionType
    The type of the function. Determines which configuration object is used.
    AwsServiceRequestConfiguration FunctionAwsServiceRequestConfigurationArgs
    ConcurrentExecutorConfiguration FunctionConcurrentExecutorConfigurationArgs
    The configuration for a CONCURRENT_EXECUTOR function. Required when FunctionType is CONCURRENT_EXECUTOR.
    CustomOutputConfiguration FunctionCustomOutputConfigurationArgs
    Description string
    A description of the function.
    HttpRequestConfiguration FunctionHttpRequestConfigurationArgs
    SequentialExecutorConfiguration FunctionSequentialExecutorConfigurationArgs
    Tags TagArgs
    The tags to assign to the function resource.
    VastRequestConfiguration FunctionVastRequestConfigurationArgs
    function_id string
    The unique identifier for the function.
    function_type "HTTP_REQUEST" | "AWS_SERVICE_REQUEST" | "CUSTOM_OUTPUT" | "CONCURRENT_EXECUTOR" | "SEQUENTIAL_EXECUTOR" | "VAST_REQUEST"
    The type of the function. Determines which configuration object is used.
    aws_service_request_configuration object
    concurrent_executor_configuration object
    The configuration for a CONCURRENT_EXECUTOR function. Required when FunctionType is CONCURRENT_EXECUTOR.
    custom_output_configuration object
    description string
    A description of the function.
    http_request_configuration object
    sequential_executor_configuration object
    tags list(object)
    The tags to assign to the function resource.
    vast_request_configuration object
    functionId String
    The unique identifier for the function.
    functionType FunctionType
    The type of the function. Determines which configuration object is used.
    awsServiceRequestConfiguration FunctionAwsServiceRequestConfiguration
    concurrentExecutorConfiguration FunctionConcurrentExecutorConfiguration
    The configuration for a CONCURRENT_EXECUTOR function. Required when FunctionType is CONCURRENT_EXECUTOR.
    customOutputConfiguration FunctionCustomOutputConfiguration
    description String
    A description of the function.
    httpRequestConfiguration FunctionHttpRequestConfiguration
    sequentialExecutorConfiguration FunctionSequentialExecutorConfiguration
    tags List<Tag>
    The tags to assign to the function resource.
    vastRequestConfiguration FunctionVastRequestConfiguration
    functionId string
    The unique identifier for the function.
    functionType FunctionType
    The type of the function. Determines which configuration object is used.
    awsServiceRequestConfiguration FunctionAwsServiceRequestConfiguration
    concurrentExecutorConfiguration FunctionConcurrentExecutorConfiguration
    The configuration for a CONCURRENT_EXECUTOR function. Required when FunctionType is CONCURRENT_EXECUTOR.
    customOutputConfiguration FunctionCustomOutputConfiguration
    description string
    A description of the function.
    httpRequestConfiguration FunctionHttpRequestConfiguration
    sequentialExecutorConfiguration FunctionSequentialExecutorConfiguration
    tags Tag[]
    The tags to assign to the function resource.
    vastRequestConfiguration FunctionVastRequestConfiguration
    functionId String
    The unique identifier for the function.
    functionType "HTTP_REQUEST" | "AWS_SERVICE_REQUEST" | "CUSTOM_OUTPUT" | "CONCURRENT_EXECUTOR" | "SEQUENTIAL_EXECUTOR" | "VAST_REQUEST"
    The type of the function. Determines which configuration object is used.
    awsServiceRequestConfiguration Property Map
    concurrentExecutorConfiguration Property Map
    The configuration for a CONCURRENT_EXECUTOR function. Required when FunctionType is CONCURRENT_EXECUTOR.
    customOutputConfiguration Property Map
    description String
    A description of the function.
    httpRequestConfiguration Property Map
    sequentialExecutorConfiguration Property Map
    tags List<Property Map>
    The tags to assign to the function resource.
    vastRequestConfiguration Property Map

    Outputs

    All input properties are implicitly available as output properties. Additionally, the Function resource produces the following output properties:

    Arn string
    The ARN of the function.
    Id string
    The provider-assigned unique ID for this managed resource.
    Arn string
    The ARN of the function.
    Id string
    The provider-assigned unique ID for this managed resource.
    arn string
    The ARN of the function.
    id string
    The provider-assigned unique ID for this managed resource.
    arn String
    The ARN of the function.
    id String
    The provider-assigned unique ID for this managed resource.
    arn string
    The ARN of the function.
    id string
    The provider-assigned unique ID for this managed resource.
    arn str
    The ARN of the function.
    id str
    The provider-assigned unique ID for this managed resource.
    arn String
    The ARN of the function.
    id String
    The provider-assigned unique ID for this managed resource.

    Supporting Types

    FunctionAwsServiceRequestConfiguration, FunctionAwsServiceRequestConfigurationArgs

    The configuration for an AWS_SERVICE_REQUEST function. Contains the target service, target Region, and request parameters that the function uses to call an AWS service API. For more information, see AWS_SERVICE_REQUEST (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-types-aws-service-request.html) in the MediaTailor User Guide.
    MethodType Pulumi.AwsNative.MediaTailor.FunctionMethodType
    RequestTimeoutMilliseconds int
    The maximum time, in milliseconds, that MediaTailor waits for a response from the AWS service. If the call exceeds this timeout, MediaTailor sets the response status code to null and proceeds with output expression evaluation. Valid values are 100 to 2000.
    Runtime Pulumi.AwsNative.MediaTailor.FunctionRuntimeType
    TargetRegion string
    The AWS Region for the target service. Specify a static Region code (for example, us-east-1) or a JSONata expression that resolves to a Region code at runtime (for example, {%inference.region%}).
    TargetService string
    The AWS service to call. Valid value: elemental-inference (AWS Elemental Inference).
    Url string
    An expression that evaluates to the endpoint URL for the target AWS service API operation. Use {%...%} delimiters for dynamic expressions. The URL must correspond to a valid endpoint for the service specified in TargetService. The maximum length after evaluation is 2,048 characters.
    Body string
    An expression that evaluates to the request body for the AWS service API call. The body must conform to the input format that the target service operation expects. Applies only when the target operation accepts a request body. The maximum size after evaluation is 64 KB.
    Cache Pulumi.AwsNative.MediaTailor.Inputs.FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the AWS service, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    Headers Dictionary<string, string>
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request to the AWS service. Use this to pass any headers required by the target service operation. You can include a maximum of 50 headers.
    Output Dictionary<string, string>
    A map of output bindings. Each key is a namespaced output path, such as player_params.device_type. Each value is an expression that MediaTailor evaluates at runtime and can reference the response object from the target service. For more information, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    MethodType FunctionMethodType
    RequestTimeoutMilliseconds int
    The maximum time, in milliseconds, that MediaTailor waits for a response from the AWS service. If the call exceeds this timeout, MediaTailor sets the response status code to null and proceeds with output expression evaluation. Valid values are 100 to 2000.
    Runtime FunctionRuntimeType
    TargetRegion string
    The AWS Region for the target service. Specify a static Region code (for example, us-east-1) or a JSONata expression that resolves to a Region code at runtime (for example, {%inference.region%}).
    TargetService string
    The AWS service to call. Valid value: elemental-inference (AWS Elemental Inference).
    Url string
    An expression that evaluates to the endpoint URL for the target AWS service API operation. Use {%...%} delimiters for dynamic expressions. The URL must correspond to a valid endpoint for the service specified in TargetService. The maximum length after evaluation is 2,048 characters.
    Body string
    An expression that evaluates to the request body for the AWS service API call. The body must conform to the input format that the target service operation expects. Applies only when the target operation accepts a request body. The maximum size after evaluation is 64 KB.
    Cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the AWS service, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    Headers map[string]string
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request to the AWS service. Use this to pass any headers required by the target service operation. You can include a maximum of 50 headers.
    Output map[string]string
    A map of output bindings. Each key is a namespaced output path, such as player_params.device_type. Each value is an expression that MediaTailor evaluates at runtime and can reference the response object from the target service. For more information, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    method_type "GET" | "POST"
    request_timeout_milliseconds number
    The maximum time, in milliseconds, that MediaTailor waits for a response from the AWS service. If the call exceeds this timeout, MediaTailor sets the response status code to null and proceeds with output expression evaluation. Valid values are 100 to 2000.
    runtime "JSONATA"
    target_region string
    The AWS Region for the target service. Specify a static Region code (for example, us-east-1) or a JSONata expression that resolves to a Region code at runtime (for example, {%inference.region%}).
    target_service string
    The AWS service to call. Valid value: elemental-inference (AWS Elemental Inference).
    url string
    An expression that evaluates to the endpoint URL for the target AWS service API operation. Use {%...%} delimiters for dynamic expressions. The URL must correspond to a valid endpoint for the service specified in TargetService. The maximum length after evaluation is 2,048 characters.
    body string
    An expression that evaluates to the request body for the AWS service API call. The body must conform to the input format that the target service operation expects. Applies only when the target operation accepts a request body. The maximum size after evaluation is 64 KB.
    cache object
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the AWS service, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers map(string)
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request to the AWS service. Use this to pass any headers required by the target service operation. You can include a maximum of 50 headers.
    output map(string)
    A map of output bindings. Each key is a namespaced output path, such as player_params.device_type. Each value is an expression that MediaTailor evaluates at runtime and can reference the response object from the target service. For more information, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    methodType FunctionMethodType
    requestTimeoutMilliseconds Integer
    The maximum time, in milliseconds, that MediaTailor waits for a response from the AWS service. If the call exceeds this timeout, MediaTailor sets the response status code to null and proceeds with output expression evaluation. Valid values are 100 to 2000.
    runtime FunctionRuntimeType
    targetRegion String
    The AWS Region for the target service. Specify a static Region code (for example, us-east-1) or a JSONata expression that resolves to a Region code at runtime (for example, {%inference.region%}).
    targetService String
    The AWS service to call. Valid value: elemental-inference (AWS Elemental Inference).
    url String
    An expression that evaluates to the endpoint URL for the target AWS service API operation. Use {%...%} delimiters for dynamic expressions. The URL must correspond to a valid endpoint for the service specified in TargetService. The maximum length after evaluation is 2,048 characters.
    body String
    An expression that evaluates to the request body for the AWS service API call. The body must conform to the input format that the target service operation expects. Applies only when the target operation accepts a request body. The maximum size after evaluation is 64 KB.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the AWS service, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Map<String,String>
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request to the AWS service. Use this to pass any headers required by the target service operation. You can include a maximum of 50 headers.
    output Map<String,String>
    A map of output bindings. Each key is a namespaced output path, such as player_params.device_type. Each value is an expression that MediaTailor evaluates at runtime and can reference the response object from the target service. For more information, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    methodType FunctionMethodType
    requestTimeoutMilliseconds number
    The maximum time, in milliseconds, that MediaTailor waits for a response from the AWS service. If the call exceeds this timeout, MediaTailor sets the response status code to null and proceeds with output expression evaluation. Valid values are 100 to 2000.
    runtime FunctionRuntimeType
    targetRegion string
    The AWS Region for the target service. Specify a static Region code (for example, us-east-1) or a JSONata expression that resolves to a Region code at runtime (for example, {%inference.region%}).
    targetService string
    The AWS service to call. Valid value: elemental-inference (AWS Elemental Inference).
    url string
    An expression that evaluates to the endpoint URL for the target AWS service API operation. Use {%...%} delimiters for dynamic expressions. The URL must correspond to a valid endpoint for the service specified in TargetService. The maximum length after evaluation is 2,048 characters.
    body string
    An expression that evaluates to the request body for the AWS service API call. The body must conform to the input format that the target service operation expects. Applies only when the target operation accepts a request body. The maximum size after evaluation is 64 KB.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the AWS service, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers {[key: string]: string}
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request to the AWS service. Use this to pass any headers required by the target service operation. You can include a maximum of 50 headers.
    output {[key: string]: string}
    A map of output bindings. Each key is a namespaced output path, such as player_params.device_type. Each value is an expression that MediaTailor evaluates at runtime and can reference the response object from the target service. For more information, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    method_type FunctionMethodType
    request_timeout_milliseconds int
    The maximum time, in milliseconds, that MediaTailor waits for a response from the AWS service. If the call exceeds this timeout, MediaTailor sets the response status code to null and proceeds with output expression evaluation. Valid values are 100 to 2000.
    runtime FunctionRuntimeType
    target_region str
    The AWS Region for the target service. Specify a static Region code (for example, us-east-1) or a JSONata expression that resolves to a Region code at runtime (for example, {%inference.region%}).
    target_service str
    The AWS service to call. Valid value: elemental-inference (AWS Elemental Inference).
    url str
    An expression that evaluates to the endpoint URL for the target AWS service API operation. Use {%...%} delimiters for dynamic expressions. The URL must correspond to a valid endpoint for the service specified in TargetService. The maximum length after evaluation is 2,048 characters.
    body str
    An expression that evaluates to the request body for the AWS service API call. The body must conform to the input format that the target service operation expects. Applies only when the target operation accepts a request body. The maximum size after evaluation is 64 KB.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the AWS service, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Mapping[str, str]
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request to the AWS service. Use this to pass any headers required by the target service operation. You can include a maximum of 50 headers.
    output Mapping[str, str]
    A map of output bindings. Each key is a namespaced output path, such as player_params.device_type. Each value is an expression that MediaTailor evaluates at runtime and can reference the response object from the target service. For more information, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    methodType "GET" | "POST"
    requestTimeoutMilliseconds Number
    The maximum time, in milliseconds, that MediaTailor waits for a response from the AWS service. If the call exceeds this timeout, MediaTailor sets the response status code to null and proceeds with output expression evaluation. Valid values are 100 to 2000.
    runtime "JSONATA"
    targetRegion String
    The AWS Region for the target service. Specify a static Region code (for example, us-east-1) or a JSONata expression that resolves to a Region code at runtime (for example, {%inference.region%}).
    targetService String
    The AWS service to call. Valid value: elemental-inference (AWS Elemental Inference).
    url String
    An expression that evaluates to the endpoint URL for the target AWS service API operation. Use {%...%} delimiters for dynamic expressions. The URL must correspond to a valid endpoint for the service specified in TargetService. The maximum length after evaluation is 2,048 characters.
    body String
    An expression that evaluates to the request body for the AWS service API call. The body must conform to the input format that the target service operation expects. Applies only when the target operation accepts a request body. The maximum size after evaluation is 64 KB.
    cache Property Map
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the AWS service, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Map<String>
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request to the AWS service. Use this to pass any headers required by the target service operation. You can include a maximum of 50 headers.
    output Map<String>
    A map of output bindings. Each key is a namespaced output path, such as player_params.device_type. Each value is an expression that MediaTailor evaluates at runtime and can reference the response object from the target service. For more information, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.

    FunctionConcurrentExecutorConfiguration, FunctionConcurrentExecutorConfigurationArgs

    The configuration for a CONCURRENT_EXECUTOR function. A CONCURRENT_EXECUTOR runs a set of child functions in parallel, up to a maximum concurrency, and combines their output when all functions complete. For more information about functions, see Working with functions (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions.html) in the MediaTailor User Guide.
    FunctionList List<Pulumi.AwsNative.MediaTailor.Inputs.FunctionRef>
    The list of 1 to 10 child functions that MediaTailor runs in parallel. Each entry specifies a child function to execute and an optional run condition expression that controls whether the function runs. Child functions cannot themselves be executors, and each child function's resolved namespace must be unique across the list.
    MaxConcurrency int
    The maximum number of child functions that MediaTailor runs simultaneously. When the list contains more functions than MaxConcurrency, MediaTailor starts additional functions as running ones complete, so that no more than MaxConcurrency functions run at the same time. Valid values are 1 to 2.
    Output Dictionary<string, string>
    A map of output bindings that controls which bindings the executor commits to the session state after all child functions complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the combined results of the child functions.
    Runtime Pulumi.AwsNative.MediaTailor.FunctionRuntimeType
    TimeoutMilliseconds int
    The maximum time, in milliseconds, for all child functions to complete. This timeout covers every function in the list, including any HTTP calls the child functions make. If the executor exceeds this timeout, MediaTailor discards all output from the executor and proceeds with default behavior. Valid values are 100 to 2000.
    FunctionList []FunctionRef
    The list of 1 to 10 child functions that MediaTailor runs in parallel. Each entry specifies a child function to execute and an optional run condition expression that controls whether the function runs. Child functions cannot themselves be executors, and each child function's resolved namespace must be unique across the list.
    MaxConcurrency int
    The maximum number of child functions that MediaTailor runs simultaneously. When the list contains more functions than MaxConcurrency, MediaTailor starts additional functions as running ones complete, so that no more than MaxConcurrency functions run at the same time. Valid values are 1 to 2.
    Output map[string]string
    A map of output bindings that controls which bindings the executor commits to the session state after all child functions complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the combined results of the child functions.
    Runtime FunctionRuntimeType
    TimeoutMilliseconds int
    The maximum time, in milliseconds, for all child functions to complete. This timeout covers every function in the list, including any HTTP calls the child functions make. If the executor exceeds this timeout, MediaTailor discards all output from the executor and proceeds with default behavior. Valid values are 100 to 2000.
    function_list list(object)
    The list of 1 to 10 child functions that MediaTailor runs in parallel. Each entry specifies a child function to execute and an optional run condition expression that controls whether the function runs. Child functions cannot themselves be executors, and each child function's resolved namespace must be unique across the list.
    max_concurrency number
    The maximum number of child functions that MediaTailor runs simultaneously. When the list contains more functions than MaxConcurrency, MediaTailor starts additional functions as running ones complete, so that no more than MaxConcurrency functions run at the same time. Valid values are 1 to 2.
    output map(string)
    A map of output bindings that controls which bindings the executor commits to the session state after all child functions complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the combined results of the child functions.
    runtime "JSONATA"
    timeout_milliseconds number
    The maximum time, in milliseconds, for all child functions to complete. This timeout covers every function in the list, including any HTTP calls the child functions make. If the executor exceeds this timeout, MediaTailor discards all output from the executor and proceeds with default behavior. Valid values are 100 to 2000.
    functionList List<FunctionRef>
    The list of 1 to 10 child functions that MediaTailor runs in parallel. Each entry specifies a child function to execute and an optional run condition expression that controls whether the function runs. Child functions cannot themselves be executors, and each child function's resolved namespace must be unique across the list.
    maxConcurrency Integer
    The maximum number of child functions that MediaTailor runs simultaneously. When the list contains more functions than MaxConcurrency, MediaTailor starts additional functions as running ones complete, so that no more than MaxConcurrency functions run at the same time. Valid values are 1 to 2.
    output Map<String,String>
    A map of output bindings that controls which bindings the executor commits to the session state after all child functions complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the combined results of the child functions.
    runtime FunctionRuntimeType
    timeoutMilliseconds Integer
    The maximum time, in milliseconds, for all child functions to complete. This timeout covers every function in the list, including any HTTP calls the child functions make. If the executor exceeds this timeout, MediaTailor discards all output from the executor and proceeds with default behavior. Valid values are 100 to 2000.
    functionList FunctionRef[]
    The list of 1 to 10 child functions that MediaTailor runs in parallel. Each entry specifies a child function to execute and an optional run condition expression that controls whether the function runs. Child functions cannot themselves be executors, and each child function's resolved namespace must be unique across the list.
    maxConcurrency number
    The maximum number of child functions that MediaTailor runs simultaneously. When the list contains more functions than MaxConcurrency, MediaTailor starts additional functions as running ones complete, so that no more than MaxConcurrency functions run at the same time. Valid values are 1 to 2.
    output {[key: string]: string}
    A map of output bindings that controls which bindings the executor commits to the session state after all child functions complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the combined results of the child functions.
    runtime FunctionRuntimeType
    timeoutMilliseconds number
    The maximum time, in milliseconds, for all child functions to complete. This timeout covers every function in the list, including any HTTP calls the child functions make. If the executor exceeds this timeout, MediaTailor discards all output from the executor and proceeds with default behavior. Valid values are 100 to 2000.
    function_list Sequence[FunctionRef]
    The list of 1 to 10 child functions that MediaTailor runs in parallel. Each entry specifies a child function to execute and an optional run condition expression that controls whether the function runs. Child functions cannot themselves be executors, and each child function's resolved namespace must be unique across the list.
    max_concurrency int
    The maximum number of child functions that MediaTailor runs simultaneously. When the list contains more functions than MaxConcurrency, MediaTailor starts additional functions as running ones complete, so that no more than MaxConcurrency functions run at the same time. Valid values are 1 to 2.
    output Mapping[str, str]
    A map of output bindings that controls which bindings the executor commits to the session state after all child functions complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the combined results of the child functions.
    runtime FunctionRuntimeType
    timeout_milliseconds int
    The maximum time, in milliseconds, for all child functions to complete. This timeout covers every function in the list, including any HTTP calls the child functions make. If the executor exceeds this timeout, MediaTailor discards all output from the executor and proceeds with default behavior. Valid values are 100 to 2000.
    functionList List<Property Map>
    The list of 1 to 10 child functions that MediaTailor runs in parallel. Each entry specifies a child function to execute and an optional run condition expression that controls whether the function runs. Child functions cannot themselves be executors, and each child function's resolved namespace must be unique across the list.
    maxConcurrency Number
    The maximum number of child functions that MediaTailor runs simultaneously. When the list contains more functions than MaxConcurrency, MediaTailor starts additional functions as running ones complete, so that no more than MaxConcurrency functions run at the same time. Valid values are 1 to 2.
    output Map<String>
    A map of output bindings that controls which bindings the executor commits to the session state after all child functions complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the combined results of the child functions.
    runtime "JSONATA"
    timeoutMilliseconds Number
    The maximum time, in milliseconds, for all child functions to complete. This timeout covers every function in the list, including any HTTP calls the child functions make. If the executor exceeds this timeout, MediaTailor discards all output from the executor and proceeds with default behavior. Valid values are 100 to 2000.

    FunctionCustomOutputConfiguration, FunctionCustomOutputConfigurationArgs

    Configuration for custom output functions.
    Runtime Pulumi.AwsNative.MediaTailor.FunctionRuntimeType
    The runtime environment for the function expression language.
    Output Dictionary<string, string>
    A map of output key-value pairs that define the custom output.
    Runtime FunctionRuntimeType
    The runtime environment for the function expression language.
    Output map[string]string
    A map of output key-value pairs that define the custom output.
    runtime "JSONATA"
    The runtime environment for the function expression language.
    output map(string)
    A map of output key-value pairs that define the custom output.
    runtime FunctionRuntimeType
    The runtime environment for the function expression language.
    output Map<String,String>
    A map of output key-value pairs that define the custom output.
    runtime FunctionRuntimeType
    The runtime environment for the function expression language.
    output {[key: string]: string}
    A map of output key-value pairs that define the custom output.
    runtime FunctionRuntimeType
    The runtime environment for the function expression language.
    output Mapping[str, str]
    A map of output key-value pairs that define the custom output.
    runtime "JSONATA"
    The runtime environment for the function expression language.
    output Map<String>
    A map of output key-value pairs that define the custom output.

    FunctionHttpRequestCacheConfiguration, FunctionHttpRequestCacheConfigurationArgs

    The optional response-caching configuration shared by the HTTP-based function types (HTTP_REQUEST, AWS_SERVICE_REQUEST, and VAST_REQUEST). When you provide this configuration, MediaTailor caches function responses with HTTP status codes 200, 203, 204, 404, 405, 410, 414, or 501. For a cacheable response, MediaTailor uses the Cache-Control max-age directive limited to the range between TtlMinimumSeconds and TtlMaximumSeconds. If no max-age directive is present, MediaTailor uses TtlMinimumSeconds. Cached HTTP responses are scoped per playback configuration, not per function.
    TtlMaximumSeconds int
    The upper bound, in seconds, on how long MediaTailor caches a response. This value must be greater than or equal to TtlMinimumSeconds.
    TtlMinimumSeconds int
    The lower bound, in seconds, on how long MediaTailor caches a response. MediaTailor also uses this value as the cache duration when a response has no Cache-Control max-age directive.
    Key string
    A JSONata expression that MediaTailor evaluates to a custom cache key. By default, the cache key is a hash of the HTTP URL, request body, and HTTP method; request headers are not included. The evaluated key must be smaller than 1 KB.
    TtlMaximumSeconds int
    The upper bound, in seconds, on how long MediaTailor caches a response. This value must be greater than or equal to TtlMinimumSeconds.
    TtlMinimumSeconds int
    The lower bound, in seconds, on how long MediaTailor caches a response. MediaTailor also uses this value as the cache duration when a response has no Cache-Control max-age directive.
    Key string
    A JSONata expression that MediaTailor evaluates to a custom cache key. By default, the cache key is a hash of the HTTP URL, request body, and HTTP method; request headers are not included. The evaluated key must be smaller than 1 KB.
    ttl_maximum_seconds number
    The upper bound, in seconds, on how long MediaTailor caches a response. This value must be greater than or equal to TtlMinimumSeconds.
    ttl_minimum_seconds number
    The lower bound, in seconds, on how long MediaTailor caches a response. MediaTailor also uses this value as the cache duration when a response has no Cache-Control max-age directive.
    key string
    A JSONata expression that MediaTailor evaluates to a custom cache key. By default, the cache key is a hash of the HTTP URL, request body, and HTTP method; request headers are not included. The evaluated key must be smaller than 1 KB.
    ttlMaximumSeconds Integer
    The upper bound, in seconds, on how long MediaTailor caches a response. This value must be greater than or equal to TtlMinimumSeconds.
    ttlMinimumSeconds Integer
    The lower bound, in seconds, on how long MediaTailor caches a response. MediaTailor also uses this value as the cache duration when a response has no Cache-Control max-age directive.
    key String
    A JSONata expression that MediaTailor evaluates to a custom cache key. By default, the cache key is a hash of the HTTP URL, request body, and HTTP method; request headers are not included. The evaluated key must be smaller than 1 KB.
    ttlMaximumSeconds number
    The upper bound, in seconds, on how long MediaTailor caches a response. This value must be greater than or equal to TtlMinimumSeconds.
    ttlMinimumSeconds number
    The lower bound, in seconds, on how long MediaTailor caches a response. MediaTailor also uses this value as the cache duration when a response has no Cache-Control max-age directive.
    key string
    A JSONata expression that MediaTailor evaluates to a custom cache key. By default, the cache key is a hash of the HTTP URL, request body, and HTTP method; request headers are not included. The evaluated key must be smaller than 1 KB.
    ttl_maximum_seconds int
    The upper bound, in seconds, on how long MediaTailor caches a response. This value must be greater than or equal to TtlMinimumSeconds.
    ttl_minimum_seconds int
    The lower bound, in seconds, on how long MediaTailor caches a response. MediaTailor also uses this value as the cache duration when a response has no Cache-Control max-age directive.
    key str
    A JSONata expression that MediaTailor evaluates to a custom cache key. By default, the cache key is a hash of the HTTP URL, request body, and HTTP method; request headers are not included. The evaluated key must be smaller than 1 KB.
    ttlMaximumSeconds Number
    The upper bound, in seconds, on how long MediaTailor caches a response. This value must be greater than or equal to TtlMinimumSeconds.
    ttlMinimumSeconds Number
    The lower bound, in seconds, on how long MediaTailor caches a response. MediaTailor also uses this value as the cache duration when a response has no Cache-Control max-age directive.
    key String
    A JSONata expression that MediaTailor evaluates to a custom cache key. By default, the cache key is a hash of the HTTP URL, request body, and HTTP method; request headers are not included. The evaluated key must be smaller than 1 KB.

    FunctionHttpRequestConfiguration, FunctionHttpRequestConfigurationArgs

    Configuration for HTTP request functions.
    MethodType Pulumi.AwsNative.MediaTailor.FunctionMethodType
    The HTTP method type for the request.
    RequestTimeoutMilliseconds int
    The timeout in milliseconds for the HTTP request. Maximum value is 2000.
    Runtime Pulumi.AwsNative.MediaTailor.FunctionRuntimeType
    The runtime environment for the function expression language.
    Url string
    The URL endpoint for the HTTP request.
    Body string
    The body of the HTTP request.
    Cache Pulumi.AwsNative.MediaTailor.Inputs.FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    Headers Dictionary<string, string>
    A map of HTTP headers to include in the request.
    Output Dictionary<string, string>
    A map of output key-value pairs. Keys must start with session., temp., avail., scte., or be a valid adsRequest directive.
    MethodType FunctionMethodType
    The HTTP method type for the request.
    RequestTimeoutMilliseconds int
    The timeout in milliseconds for the HTTP request. Maximum value is 2000.
    Runtime FunctionRuntimeType
    The runtime environment for the function expression language.
    Url string
    The URL endpoint for the HTTP request.
    Body string
    The body of the HTTP request.
    Cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    Headers map[string]string
    A map of HTTP headers to include in the request.
    Output map[string]string
    A map of output key-value pairs. Keys must start with session., temp., avail., scte., or be a valid adsRequest directive.
    method_type "GET" | "POST"
    The HTTP method type for the request.
    request_timeout_milliseconds number
    The timeout in milliseconds for the HTTP request. Maximum value is 2000.
    runtime "JSONATA"
    The runtime environment for the function expression language.
    url string
    The URL endpoint for the HTTP request.
    body string
    The body of the HTTP request.
    cache object
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers map(string)
    A map of HTTP headers to include in the request.
    output map(string)
    A map of output key-value pairs. Keys must start with session., temp., avail., scte., or be a valid adsRequest directive.
    methodType FunctionMethodType
    The HTTP method type for the request.
    requestTimeoutMilliseconds Integer
    The timeout in milliseconds for the HTTP request. Maximum value is 2000.
    runtime FunctionRuntimeType
    The runtime environment for the function expression language.
    url String
    The URL endpoint for the HTTP request.
    body String
    The body of the HTTP request.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Map<String,String>
    A map of HTTP headers to include in the request.
    output Map<String,String>
    A map of output key-value pairs. Keys must start with session., temp., avail., scte., or be a valid adsRequest directive.
    methodType FunctionMethodType
    The HTTP method type for the request.
    requestTimeoutMilliseconds number
    The timeout in milliseconds for the HTTP request. Maximum value is 2000.
    runtime FunctionRuntimeType
    The runtime environment for the function expression language.
    url string
    The URL endpoint for the HTTP request.
    body string
    The body of the HTTP request.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers {[key: string]: string}
    A map of HTTP headers to include in the request.
    output {[key: string]: string}
    A map of output key-value pairs. Keys must start with session., temp., avail., scte., or be a valid adsRequest directive.
    method_type FunctionMethodType
    The HTTP method type for the request.
    request_timeout_milliseconds int
    The timeout in milliseconds for the HTTP request. Maximum value is 2000.
    runtime FunctionRuntimeType
    The runtime environment for the function expression language.
    url str
    The URL endpoint for the HTTP request.
    body str
    The body of the HTTP request.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Mapping[str, str]
    A map of HTTP headers to include in the request.
    output Mapping[str, str]
    A map of output key-value pairs. Keys must start with session., temp., avail., scte., or be a valid adsRequest directive.
    methodType "GET" | "POST"
    The HTTP method type for the request.
    requestTimeoutMilliseconds Number
    The timeout in milliseconds for the HTTP request. Maximum value is 2000.
    runtime "JSONATA"
    The runtime environment for the function expression language.
    url String
    The URL endpoint for the HTTP request.
    body String
    The body of the HTTP request.
    cache Property Map
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Map<String>
    A map of HTTP headers to include in the request.
    output Map<String>
    A map of output key-value pairs. Keys must start with session., temp., avail., scte., or be a valid adsRequest directive.

    FunctionMethodType, FunctionMethodTypeArgs

    Get
    GET
    Post
    POST
    FunctionMethodTypeGet
    GET
    FunctionMethodTypePost
    POST
    "GET"
    GET
    "POST"
    POST
    Get
    GET
    Post
    POST
    Get
    GET
    Post
    POST
    GET
    GET
    POST
    POST
    "GET"
    GET
    "POST"
    POST

    FunctionRef, FunctionRefArgs

    A reference to a child function within an executor function.
    Alias string
    An optional alternate name for the child function within the executor. MediaTailor uses this value as the namespace for the child function's output. If omitted, MediaTailor uses the function identifier. The resolved namespace must be unique across all child functions in the list.
    FunctionId string
    The identifier of the child function to execute.
    RunCondition string
    An optional expression that evaluates to a boolean. MediaTailor evaluates this expression immediately before running the child function, using the accumulated state at that point. If the expression evaluates to false, MediaTailor skips the child function. If omitted, the child function always runs.
    Alias string
    An optional alternate name for the child function within the executor. MediaTailor uses this value as the namespace for the child function's output. If omitted, MediaTailor uses the function identifier. The resolved namespace must be unique across all child functions in the list.
    FunctionId string
    The identifier of the child function to execute.
    RunCondition string
    An optional expression that evaluates to a boolean. MediaTailor evaluates this expression immediately before running the child function, using the accumulated state at that point. If the expression evaluates to false, MediaTailor skips the child function. If omitted, the child function always runs.
    alias string
    An optional alternate name for the child function within the executor. MediaTailor uses this value as the namespace for the child function's output. If omitted, MediaTailor uses the function identifier. The resolved namespace must be unique across all child functions in the list.
    function_id string
    The identifier of the child function to execute.
    run_condition string
    An optional expression that evaluates to a boolean. MediaTailor evaluates this expression immediately before running the child function, using the accumulated state at that point. If the expression evaluates to false, MediaTailor skips the child function. If omitted, the child function always runs.
    alias String
    An optional alternate name for the child function within the executor. MediaTailor uses this value as the namespace for the child function's output. If omitted, MediaTailor uses the function identifier. The resolved namespace must be unique across all child functions in the list.
    functionId String
    The identifier of the child function to execute.
    runCondition String
    An optional expression that evaluates to a boolean. MediaTailor evaluates this expression immediately before running the child function, using the accumulated state at that point. If the expression evaluates to false, MediaTailor skips the child function. If omitted, the child function always runs.
    alias string
    An optional alternate name for the child function within the executor. MediaTailor uses this value as the namespace for the child function's output. If omitted, MediaTailor uses the function identifier. The resolved namespace must be unique across all child functions in the list.
    functionId string
    The identifier of the child function to execute.
    runCondition string
    An optional expression that evaluates to a boolean. MediaTailor evaluates this expression immediately before running the child function, using the accumulated state at that point. If the expression evaluates to false, MediaTailor skips the child function. If omitted, the child function always runs.
    alias str
    An optional alternate name for the child function within the executor. MediaTailor uses this value as the namespace for the child function's output. If omitted, MediaTailor uses the function identifier. The resolved namespace must be unique across all child functions in the list.
    function_id str
    The identifier of the child function to execute.
    run_condition str
    An optional expression that evaluates to a boolean. MediaTailor evaluates this expression immediately before running the child function, using the accumulated state at that point. If the expression evaluates to false, MediaTailor skips the child function. If omitted, the child function always runs.
    alias String
    An optional alternate name for the child function within the executor. MediaTailor uses this value as the namespace for the child function's output. If omitted, MediaTailor uses the function identifier. The resolved namespace must be unique across all child functions in the list.
    functionId String
    The identifier of the child function to execute.
    runCondition String
    An optional expression that evaluates to a boolean. MediaTailor evaluates this expression immediately before running the child function, using the accumulated state at that point. If the expression evaluates to false, MediaTailor skips the child function. If omitted, the child function always runs.

    FunctionRuntimeType, FunctionRuntimeTypeArgs

    Jsonata
    JSONATA
    FunctionRuntimeTypeJsonata
    JSONATA
    "JSONATA"
    JSONATA
    Jsonata
    JSONATA
    Jsonata
    JSONATA
    JSONATA
    JSONATA
    "JSONATA"
    JSONATA

    FunctionSequentialExecutorConfiguration, FunctionSequentialExecutorConfigurationArgs

    The configuration for a SEQUENTIAL_EXECUTOR function. A SEQUENTIAL_EXECUTOR runs an ordered list of child functions one at a time, passing data between them. For more information about functions, see Working with functions (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions.html) in the MediaTailor User Guide.
    FunctionList List<Pulumi.AwsNative.MediaTailor.Inputs.FunctionRef>
    An ordered list of 1 to 10 steps. Each step specifies a child function to execute and an optional run condition expression that controls whether the step runs. MediaTailor executes the steps in order, passing data between steps through temporary data. Each step's resolved namespace must be unique across the list.
    Runtime Pulumi.AwsNative.MediaTailor.FunctionRuntimeType
    TimeoutMilliseconds int
    The maximum time, in milliseconds, for the entire sequence to complete. This timeout covers all steps, including any HTTP calls made by child functions. If the sequence exceeds this timeout, MediaTailor discards all output from the sequence and proceeds with default behavior. Valid values are 100 to 2000.
    Output Dictionary<string, string>
    A map of output bindings that controls which bindings the sequence commits to the session state after all steps complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the accumulated results of the steps.
    FunctionList []FunctionRef
    An ordered list of 1 to 10 steps. Each step specifies a child function to execute and an optional run condition expression that controls whether the step runs. MediaTailor executes the steps in order, passing data between steps through temporary data. Each step's resolved namespace must be unique across the list.
    Runtime FunctionRuntimeType
    TimeoutMilliseconds int
    The maximum time, in milliseconds, for the entire sequence to complete. This timeout covers all steps, including any HTTP calls made by child functions. If the sequence exceeds this timeout, MediaTailor discards all output from the sequence and proceeds with default behavior. Valid values are 100 to 2000.
    Output map[string]string
    A map of output bindings that controls which bindings the sequence commits to the session state after all steps complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the accumulated results of the steps.
    function_list list(object)
    An ordered list of 1 to 10 steps. Each step specifies a child function to execute and an optional run condition expression that controls whether the step runs. MediaTailor executes the steps in order, passing data between steps through temporary data. Each step's resolved namespace must be unique across the list.
    runtime "JSONATA"
    timeout_milliseconds number
    The maximum time, in milliseconds, for the entire sequence to complete. This timeout covers all steps, including any HTTP calls made by child functions. If the sequence exceeds this timeout, MediaTailor discards all output from the sequence and proceeds with default behavior. Valid values are 100 to 2000.
    output map(string)
    A map of output bindings that controls which bindings the sequence commits to the session state after all steps complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the accumulated results of the steps.
    functionList List<FunctionRef>
    An ordered list of 1 to 10 steps. Each step specifies a child function to execute and an optional run condition expression that controls whether the step runs. MediaTailor executes the steps in order, passing data between steps through temporary data. Each step's resolved namespace must be unique across the list.
    runtime FunctionRuntimeType
    timeoutMilliseconds Integer
    The maximum time, in milliseconds, for the entire sequence to complete. This timeout covers all steps, including any HTTP calls made by child functions. If the sequence exceeds this timeout, MediaTailor discards all output from the sequence and proceeds with default behavior. Valid values are 100 to 2000.
    output Map<String,String>
    A map of output bindings that controls which bindings the sequence commits to the session state after all steps complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the accumulated results of the steps.
    functionList FunctionRef[]
    An ordered list of 1 to 10 steps. Each step specifies a child function to execute and an optional run condition expression that controls whether the step runs. MediaTailor executes the steps in order, passing data between steps through temporary data. Each step's resolved namespace must be unique across the list.
    runtime FunctionRuntimeType
    timeoutMilliseconds number
    The maximum time, in milliseconds, for the entire sequence to complete. This timeout covers all steps, including any HTTP calls made by child functions. If the sequence exceeds this timeout, MediaTailor discards all output from the sequence and proceeds with default behavior. Valid values are 100 to 2000.
    output {[key: string]: string}
    A map of output bindings that controls which bindings the sequence commits to the session state after all steps complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the accumulated results of the steps.
    function_list Sequence[FunctionRef]
    An ordered list of 1 to 10 steps. Each step specifies a child function to execute and an optional run condition expression that controls whether the step runs. MediaTailor executes the steps in order, passing data between steps through temporary data. Each step's resolved namespace must be unique across the list.
    runtime FunctionRuntimeType
    timeout_milliseconds int
    The maximum time, in milliseconds, for the entire sequence to complete. This timeout covers all steps, including any HTTP calls made by child functions. If the sequence exceeds this timeout, MediaTailor discards all output from the sequence and proceeds with default behavior. Valid values are 100 to 2000.
    output Mapping[str, str]
    A map of output bindings that controls which bindings the sequence commits to the session state after all steps complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the accumulated results of the steps.
    functionList List<Property Map>
    An ordered list of 1 to 10 steps. Each step specifies a child function to execute and an optional run condition expression that controls whether the step runs. MediaTailor executes the steps in order, passing data between steps through temporary data. Each step's resolved namespace must be unique across the list.
    runtime "JSONATA"
    timeoutMilliseconds Number
    The maximum time, in milliseconds, for the entire sequence to complete. This timeout covers all steps, including any HTTP calls made by child functions. If the sequence exceeds this timeout, MediaTailor discards all output from the sequence and proceeds with default behavior. Valid values are 100 to 2000.
    output Map<String>
    A map of output bindings that controls which bindings the sequence commits to the session state after all steps complete. Each key is a namespaced output path, and each value is an expression that MediaTailor evaluates against the accumulated results of the steps.

    FunctionType, FunctionTypeArgs

    HttpRequest
    HTTP_REQUEST
    AwsServiceRequest
    AWS_SERVICE_REQUEST
    CustomOutput
    CUSTOM_OUTPUT
    ConcurrentExecutor
    CONCURRENT_EXECUTOR
    SequentialExecutor
    SEQUENTIAL_EXECUTOR
    VastRequest
    VAST_REQUEST
    FunctionTypeHttpRequest
    HTTP_REQUEST
    FunctionTypeAwsServiceRequest
    AWS_SERVICE_REQUEST
    FunctionTypeCustomOutput
    CUSTOM_OUTPUT
    FunctionTypeConcurrentExecutor
    CONCURRENT_EXECUTOR
    FunctionTypeSequentialExecutor
    SEQUENTIAL_EXECUTOR
    FunctionTypeVastRequest
    VAST_REQUEST
    "HTTP_REQUEST"
    HTTP_REQUEST
    "AWS_SERVICE_REQUEST"
    AWS_SERVICE_REQUEST
    "CUSTOM_OUTPUT"
    CUSTOM_OUTPUT
    "CONCURRENT_EXECUTOR"
    CONCURRENT_EXECUTOR
    "SEQUENTIAL_EXECUTOR"
    SEQUENTIAL_EXECUTOR
    "VAST_REQUEST"
    VAST_REQUEST
    HttpRequest
    HTTP_REQUEST
    AwsServiceRequest
    AWS_SERVICE_REQUEST
    CustomOutput
    CUSTOM_OUTPUT
    ConcurrentExecutor
    CONCURRENT_EXECUTOR
    SequentialExecutor
    SEQUENTIAL_EXECUTOR
    VastRequest
    VAST_REQUEST
    HttpRequest
    HTTP_REQUEST
    AwsServiceRequest
    AWS_SERVICE_REQUEST
    CustomOutput
    CUSTOM_OUTPUT
    ConcurrentExecutor
    CONCURRENT_EXECUTOR
    SequentialExecutor
    SEQUENTIAL_EXECUTOR
    VastRequest
    VAST_REQUEST
    HTTP_REQUEST
    HTTP_REQUEST
    AWS_SERVICE_REQUEST
    AWS_SERVICE_REQUEST
    CUSTOM_OUTPUT
    CUSTOM_OUTPUT
    CONCURRENT_EXECUTOR
    CONCURRENT_EXECUTOR
    SEQUENTIAL_EXECUTOR
    SEQUENTIAL_EXECUTOR
    VAST_REQUEST
    VAST_REQUEST
    "HTTP_REQUEST"
    HTTP_REQUEST
    "AWS_SERVICE_REQUEST"
    AWS_SERVICE_REQUEST
    "CUSTOM_OUTPUT"
    CUSTOM_OUTPUT
    "CONCURRENT_EXECUTOR"
    CONCURRENT_EXECUTOR
    "SEQUENTIAL_EXECUTOR"
    SEQUENTIAL_EXECUTOR
    "VAST_REQUEST"
    VAST_REQUEST

    FunctionVastRequestConfiguration, FunctionVastRequestConfigurationArgs

    The configuration for a VAST_REQUEST function. Specifies the HTTP method, URL, headers, body, timeout, and output expressions for a request to a VAST endpoint. MediaTailor parses the response as VAST and resolves wrapper redirects, then makes the parsed ads available to the function's output expressions. For more information, see Function types and composition (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-types.html) in the MediaTailor User Guide.
    MethodType Pulumi.AwsNative.MediaTailor.FunctionMethodType
    RequestTimeoutMilliseconds int
    The maximum time, in milliseconds, that MediaTailor waits for a response from the VAST endpoint. The timeout covers the entire response, including any wrapper redirects that MediaTailor follows. If the call exceeds this timeout, MediaTailor proceeds with an empty ad list and continues output expression evaluation. Valid values are 100 to 2000.
    Runtime Pulumi.AwsNative.MediaTailor.FunctionRuntimeType
    Url string
    An expression that evaluates to the VAST endpoint URL. Use {%...%} delimiters for dynamic expressions. A literal value must be an https:// URL. The expression can be up to 25,000 characters, and the URL after evaluation can be up to 2,048 characters.
    Body string
    An expression that evaluates to the request body, for example to send an OpenRTB bid request. The expression can be up to 100,000 characters, and the body after evaluation can be up to 64 KB.
    Cache Pulumi.AwsNative.MediaTailor.Inputs.FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    Headers Dictionary<string, string>
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request. Headers beginning with X-Amz- are reserved by the service, and method override headers are not allowed.
    Output Dictionary<string, string>
    A map of output bindings. Each key is a namespaced output path (such as temp.wrappedAds), and each value is an expression that MediaTailor evaluates at runtime. Output expressions in a VAST_REQUEST function can reference the response object, which exposes response.parsedAds, the ads parsed from the VAST response after schema validation and wrapper resolution, and response.statusCode. For more information about expression syntax, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    MethodType FunctionMethodType
    RequestTimeoutMilliseconds int
    The maximum time, in milliseconds, that MediaTailor waits for a response from the VAST endpoint. The timeout covers the entire response, including any wrapper redirects that MediaTailor follows. If the call exceeds this timeout, MediaTailor proceeds with an empty ad list and continues output expression evaluation. Valid values are 100 to 2000.
    Runtime FunctionRuntimeType
    Url string
    An expression that evaluates to the VAST endpoint URL. Use {%...%} delimiters for dynamic expressions. A literal value must be an https:// URL. The expression can be up to 25,000 characters, and the URL after evaluation can be up to 2,048 characters.
    Body string
    An expression that evaluates to the request body, for example to send an OpenRTB bid request. The expression can be up to 100,000 characters, and the body after evaluation can be up to 64 KB.
    Cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    Headers map[string]string
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request. Headers beginning with X-Amz- are reserved by the service, and method override headers are not allowed.
    Output map[string]string
    A map of output bindings. Each key is a namespaced output path (such as temp.wrappedAds), and each value is an expression that MediaTailor evaluates at runtime. Output expressions in a VAST_REQUEST function can reference the response object, which exposes response.parsedAds, the ads parsed from the VAST response after schema validation and wrapper resolution, and response.statusCode. For more information about expression syntax, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    method_type "GET" | "POST"
    request_timeout_milliseconds number
    The maximum time, in milliseconds, that MediaTailor waits for a response from the VAST endpoint. The timeout covers the entire response, including any wrapper redirects that MediaTailor follows. If the call exceeds this timeout, MediaTailor proceeds with an empty ad list and continues output expression evaluation. Valid values are 100 to 2000.
    runtime "JSONATA"
    url string
    An expression that evaluates to the VAST endpoint URL. Use {%...%} delimiters for dynamic expressions. A literal value must be an https:// URL. The expression can be up to 25,000 characters, and the URL after evaluation can be up to 2,048 characters.
    body string
    An expression that evaluates to the request body, for example to send an OpenRTB bid request. The expression can be up to 100,000 characters, and the body after evaluation can be up to 64 KB.
    cache object
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers map(string)
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request. Headers beginning with X-Amz- are reserved by the service, and method override headers are not allowed.
    output map(string)
    A map of output bindings. Each key is a namespaced output path (such as temp.wrappedAds), and each value is an expression that MediaTailor evaluates at runtime. Output expressions in a VAST_REQUEST function can reference the response object, which exposes response.parsedAds, the ads parsed from the VAST response after schema validation and wrapper resolution, and response.statusCode. For more information about expression syntax, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    methodType FunctionMethodType
    requestTimeoutMilliseconds Integer
    The maximum time, in milliseconds, that MediaTailor waits for a response from the VAST endpoint. The timeout covers the entire response, including any wrapper redirects that MediaTailor follows. If the call exceeds this timeout, MediaTailor proceeds with an empty ad list and continues output expression evaluation. Valid values are 100 to 2000.
    runtime FunctionRuntimeType
    url String
    An expression that evaluates to the VAST endpoint URL. Use {%...%} delimiters for dynamic expressions. A literal value must be an https:// URL. The expression can be up to 25,000 characters, and the URL after evaluation can be up to 2,048 characters.
    body String
    An expression that evaluates to the request body, for example to send an OpenRTB bid request. The expression can be up to 100,000 characters, and the body after evaluation can be up to 64 KB.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Map<String,String>
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request. Headers beginning with X-Amz- are reserved by the service, and method override headers are not allowed.
    output Map<String,String>
    A map of output bindings. Each key is a namespaced output path (such as temp.wrappedAds), and each value is an expression that MediaTailor evaluates at runtime. Output expressions in a VAST_REQUEST function can reference the response object, which exposes response.parsedAds, the ads parsed from the VAST response after schema validation and wrapper resolution, and response.statusCode. For more information about expression syntax, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    methodType FunctionMethodType
    requestTimeoutMilliseconds number
    The maximum time, in milliseconds, that MediaTailor waits for a response from the VAST endpoint. The timeout covers the entire response, including any wrapper redirects that MediaTailor follows. If the call exceeds this timeout, MediaTailor proceeds with an empty ad list and continues output expression evaluation. Valid values are 100 to 2000.
    runtime FunctionRuntimeType
    url string
    An expression that evaluates to the VAST endpoint URL. Use {%...%} delimiters for dynamic expressions. A literal value must be an https:// URL. The expression can be up to 25,000 characters, and the URL after evaluation can be up to 2,048 characters.
    body string
    An expression that evaluates to the request body, for example to send an OpenRTB bid request. The expression can be up to 100,000 characters, and the body after evaluation can be up to 64 KB.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers {[key: string]: string}
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request. Headers beginning with X-Amz- are reserved by the service, and method override headers are not allowed.
    output {[key: string]: string}
    A map of output bindings. Each key is a namespaced output path (such as temp.wrappedAds), and each value is an expression that MediaTailor evaluates at runtime. Output expressions in a VAST_REQUEST function can reference the response object, which exposes response.parsedAds, the ads parsed from the VAST response after schema validation and wrapper resolution, and response.statusCode. For more information about expression syntax, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    method_type FunctionMethodType
    request_timeout_milliseconds int
    The maximum time, in milliseconds, that MediaTailor waits for a response from the VAST endpoint. The timeout covers the entire response, including any wrapper redirects that MediaTailor follows. If the call exceeds this timeout, MediaTailor proceeds with an empty ad list and continues output expression evaluation. Valid values are 100 to 2000.
    runtime FunctionRuntimeType
    url str
    An expression that evaluates to the VAST endpoint URL. Use {%...%} delimiters for dynamic expressions. A literal value must be an https:// URL. The expression can be up to 25,000 characters, and the URL after evaluation can be up to 2,048 characters.
    body str
    An expression that evaluates to the request body, for example to send an OpenRTB bid request. The expression can be up to 100,000 characters, and the body after evaluation can be up to 64 KB.
    cache FunctionHttpRequestCacheConfiguration
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Mapping[str, str]
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request. Headers beginning with X-Amz- are reserved by the service, and method override headers are not allowed.
    output Mapping[str, str]
    A map of output bindings. Each key is a namespaced output path (such as temp.wrappedAds), and each value is an expression that MediaTailor evaluates at runtime. Output expressions in a VAST_REQUEST function can reference the response object, which exposes response.parsedAds, the ads parsed from the VAST response after schema validation and wrapper resolution, and response.statusCode. For more information about expression syntax, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.
    methodType "GET" | "POST"
    requestTimeoutMilliseconds Number
    The maximum time, in milliseconds, that MediaTailor waits for a response from the VAST endpoint. The timeout covers the entire response, including any wrapper redirects that MediaTailor follows. If the call exceeds this timeout, MediaTailor proceeds with an empty ad list and continues output expression evaluation. Valid values are 100 to 2000.
    runtime "JSONATA"
    url String
    An expression that evaluates to the VAST endpoint URL. Use {%...%} delimiters for dynamic expressions. A literal value must be an https:// URL. The expression can be up to 25,000 characters, and the URL after evaluation can be up to 2,048 characters.
    body String
    An expression that evaluates to the request body, for example to send an OpenRTB bid request. The expression can be up to 100,000 characters, and the body after evaluation can be up to 64 KB.
    cache Property Map
    The optional response-caching configuration for the function. When present, MediaTailor caches the responses that the function receives from the HTTP endpoint, within the time-to-live (TTL) bounds that you specify. Omit this configuration to disable response caching.
    headers Map<String>
    A map of HTTP header names to expression values. MediaTailor evaluates each header value expression at runtime and includes the result in the outbound request. Headers beginning with X-Amz- are reserved by the service, and method override headers are not allowed.
    output Map<String>
    A map of output bindings. Each key is a namespaced output path (such as temp.wrappedAds), and each value is an expression that MediaTailor evaluates at runtime. Output expressions in a VAST_REQUEST function can reference the response object, which exposes response.parsedAds, the ads parsed from the VAST response after schema validation and wrapper resolution, and response.statusCode. For more information about expression syntax, see JSONata expression reference (https://docs.aws.amazon.com/mediatailor/latest/ug/monetization-functions-jsonata.html) in the MediaTailor User Guide.

    Tag, TagArgs

    A set of tags to apply to the resource.
    Key string
    The key name of the tag
    Value string
    The value of the tag
    Key string
    The key name of the tag
    Value string
    The value of the tag
    key string
    The key name of the tag
    value string
    The value of the tag
    key String
    The key name of the tag
    value String
    The value of the tag
    key string
    The key name of the tag
    value string
    The value of the tag
    key str
    The key name of the tag
    value str
    The value of the tag
    key String
    The key name of the tag
    value String
    The value of the tag

    Package Details

    Repository
    AWS Native pulumi/pulumi-aws-native
    License
    Apache-2.0
    aws-native logo aws-native logo AWS Cloud Control

    We recommend new projects start with resources from the AWS provider.

    Viewing docs for AWS Cloud Control v1.85.0
    published on Monday, Nov 2, 2026 by Pulumi

      Try Pulumi Cloud free.
      Your team will thank you.

      Start free trial